// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  in_data.h
// ----------------------------------------------------------------------------

#ifndef in_data_h__
#define in_data_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "conf.h"
#include "spi_obj.h"
#include "map_file.h"


// ----------------------------------------------------------------------------
//  ̓f[^
// ----------------------------------------------------------------------------

class in_data : public spi_object
{
  enum input_type
  {
    IN_MEMORY = 0x0001,
    IN_FILE   = 0x0000
  };

  const uint8  *m_ptr;
  uint         m_size;
  map_file     m_mf;

  void init_input(const uint8 *data, uint len, uint flags);

public:
  in_data(const uint8 *data, uint len, uint flags)
       : m_ptr(NULL),
         m_size(0) { init_input(data, len, flags); }
  ~in_data() { m_mf.close(); }

  const uint8 *get_pointer(void) const { return m_ptr; }
  uint get_size(void) const { return m_size; }
};


#endif // in_data_h__
