// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  spi.h
// ----------------------------------------------------------------------------

#ifndef spi_h__
#define spi_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "conf.h"

#include <windows.h>
#include <time.h>


// ----------------------------------------------------------------------------
//  萔
// ----------------------------------------------------------------------------

#define SPI_MAX_PATH  200


// ----------------------------------------------------------------------------
//  ^`
// ----------------------------------------------------------------------------

#pragma pack(1)

// 摜
typedef struct
{
  long    left;
  long    top;
  long    width;
  long    height;
  WORD    x_density;
  WORD    y_density;
  short   color_depth;
  HLOCAL  info;
} picture_info;

// i[t@C
typedef struct
{
  unsigned char  method[8];
  unsigned long  position;
  unsigned long  comp_size;
  unsigned long  orig_size;
  time_t         time_stamp;
  char           path[SPI_MAX_PATH];
  char           filename[SPI_MAX_PATH];
  unsigned long  crc;
} file_info;

#pragma pack()


// R[obN֐
typedef int (__stdcall *SPI_PROGRESS_FUNC)(int, int, long);


// ----------------------------------------------------------------------------
//  vg^Cv錾
// ----------------------------------------------------------------------------

// Susie plug-in API

#define SPI_API  __stdcall
#define SPI_EXPORT  __declspec(dllexport) SPI_API

#ifdef __cplusplus
extern "C"
{
#endif // __cplusplus

// if / ax 
int SPI_EXPORT GetPluginInfo(int inInfoNo, LPSTR buf, int len);
int SPI_EXPORT IsSupported(LPSTR filename, DWORD data);
int SPI_EXPORT ConfigurationDlg(HWND parent, int func);

// 摜WJ
int SPI_EXPORT GetPictureInfo(LPSTR buf, long len, unsigned int flag,
                              picture_info *pic_info);
int SPI_EXPORT GetPicture(LPSTR buf, long len, unsigned int flag,
                          HANDLE *bmi, HANDLE *img,
                          SPI_PROGRESS_FUNC prog_func, long data);
int SPI_EXPORT GetPreview(LPSTR buf, long len, unsigned int flag,
                          HANDLE *bmi, HANDLE *img,
                          SPI_PROGRESS_FUNC prog_func, long data);

// A[JCuo
int SPI_EXPORT GetArchiveInfo(LPSTR buf, long len, unsigned int flag,
                              HLOCAL *f_info);
int SPI_EXPORT GetFileInfo(LPSTR buf, long len, LPSTR filename,
                           unsigned int flag, file_info *f_info);
int SPI_EXPORT GetFile(LPSTR src, long len, LPSTR dst, unsigned int flag,
                       SPI_PROGRESS_FUNC prog_func, long data);


#ifdef __cplusplus
}
#endif // __cplusplus

#endif // spi_h__
