// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  spi_obj.h
// ----------------------------------------------------------------------------

#ifndef spi_obj_h__
#define spi_obj_h__

// ----------------------------------------------------------------------------
//  spi_object NX
// ----------------------------------------------------------------------------

class spi_object
{
  int  m_err_code;

protected:
  void set_error_code(int err_code) { m_err_code = err_code; }

public:
  enum spi_error_code
  {
    SPI_OK = 0,
    SPI_ERROR_NOT_IMPLEMENTED = -1,
    SPI_ERROR_CANCEL = 1,
    SPI_ERROR_UNKNOWN_FORMAT = 2,
    SPI_ERROR_BROKEN_DATA = 3,
    SPI_ERROR_MEMORY_ALLOCATION = 4,
    SPI_ERROR_MEMORY = 5,
    SPI_ERROR_FILE_READ = 6,
    SPI_ERROR_ERROR = 8
  };

  spi_object(void) : m_err_code(SPI_OK) { }
  virtual ~spi_object() { }

  int get_last_error_code(void) const { return m_err_code; }
};


#endif // spi_obj_h__
